
import java.awt.*;
import java.applet.*;

public class Control extends Applet
{
    ArcControls controls;
	MyCanvas c;
	private Scrollbar vert;
	private Scrollbar horz;

    public Control() {
	setLayout(new BorderLayout());
	vert = new Scrollbar(Scrollbar.VERTICAL); 
					  // handleEvent changes vert's size when the tree grows
	horz = new Scrollbar(Scrollbar.HORIZONTAL); 
					  // handleEvent changes horz's size when the tree grows
	c = new MyCanvas(vert,horz);
//	add("North",new Button("very long button"));
	add("Center", c);
	add("North", controls = new ArcControls(c,this));
	vert.setValues(0,c.bounds().height,0,0);
	horz.setValues(0,c.bounds().width,0,0);
	add("East",vert);
	add("South",horz);

	}

    public void start() {
	controls.enable();
	
    }

    public void stop() {
	controls.disable();
    }



    public boolean handleEvent(Event e) {

	if (e.id == Event.WINDOW_DESTROY) {
	    System.exit(0);
	}
    switch (e.id) {
          case Event.SCROLL_LINE_UP:
          case Event.SCROLL_LINE_DOWN:
          case Event.SCROLL_PAGE_UP:
          case Event.SCROLL_PAGE_DOWN:
          case Event.SCROLL_ABSOLUTE:
            if (e.target == vert) {
                c.ty = ((Integer)e.arg).intValue();
                vert.setValue(c.ty);
				c.repaint();
            }

            if (e.target == horz) {
                c.tx = ((Integer)e.arg).intValue();
                horz.setValue(c.tx);
				c.repaint();
            }

 		}
	return super.handleEvent(e);
	}

    public static void main(String args[]) {
	Frame f = new Frame("MyTest");
	Control	conTest = new Control();

	conTest.init();
	conTest.start();

	f.add("Center", conTest);
	f.resize(500, 500);
	f.show();
    }
}
    

class ArcControls extends Panel {
    TextField s;
    Button pause;
	Label	info;
    MyCanvas canvas;


    public ArcControls(MyCanvas canvas,Applet a) {
	this.canvas = canvas;
	this.setBackground(Color.cyan);


  	add(info = new Label("                                 ",Label.LEFT)); 
	info.setFont (new Font ("Helvetica",Font.BOLD,12));
	add(new Button("Speed(0..99)->"));
	add(s = new TextField("0", 4));
	s.setBackground(Color.white);
	canvas.InfoLabel = info;

	add(new Button("Insert"));
	add(new Button("Delete"));
	add(new Button(" Find ")); 
	add(pause = new Button("Suspend"));
	}

    public boolean action(Event ev, Object arg) {
	try
	{
	if (ev.target instanceof Button)
	{
	    String label = (String)arg;
		int key;
		try
		{
			key =  Integer.parseInt(s.getText().trim())	;
		}catch (Exception e) {key = 101;};

		if (( key <0 || key > 99) && ( (label.compareTo("Insert") == 0) ||
			(label.compareTo("Delete") == 0)||   (label.compareTo(" Find ") == 0)||
			(label.compareTo("Speed(0..99)->") == 0)))
			{
				message("!(0 <= key <= 99)");		
				return false;
			}
	
	

		if (label.compareTo("Insert") == 0)
		{
			if(canvas.active)
			{
	 			System.out.println('\007');
				return true;
			}
			canvas.active = true;
			canvas.arg = key;
			canvas.button = 0;
			canvas.running = true;
			pause.setLabel("Suspend");
			canvas.th.resume();
			return true;

		}
		if (label.compareTo("Delete") == 0)
		{
			if(canvas.active)
			{
				System.out.println('\007');
				return true;
			}
			canvas.active = true;
			canvas.arg = key;
			canvas.button = 1;
			canvas.running = true;
			pause.setLabel("Suspend");
			canvas.th.resume();
			return true;
		}
		if (label.compareTo("Suspend") == 0)
		{
			canvas.running = false;
			((Button)ev.target).setLabel("Resume");
			return true;
		}

 		if (label.compareTo(" Find ") == 0)
		{
			if(canvas.active)
			{
				System.out.println('\007');
				return true;
			}
			canvas.active = true;
			canvas.arg = key;
			canvas.button = 2;
			canvas.running = true;
			pause.setLabel("Suspend");
			canvas.th.resume();
			return true;
		}


 		if (label.compareTo("Resume") == 0)
		{
			canvas.running = true;
			((Button)ev.target).setLabel("Suspend");
			canvas.th.resume();
			return true;
		}
		if (label.compareTo("Speed(0..99)->") == 0)
		{
			canvas.sleeptime = key;
			message("Speed is "+Integer.toString(key)); 
			return true;
		}



	}
 	}
	catch (Exception e){System.out.println('\007'+e.toString());};
	return false;   
    }
	
	public void message(String msg)
	{
		System.out.println('\007');
		info.setText(msg);
		repaint();
	}
  
}
	
