import java.awt.*;
public class MovingPoint
{
	/*uses that eq. (x-x1)*(y2-y1)-(y-y1)*(x2-x1)=0 represents a line through 2 points.
	also uses the formula to compute a distance from a line to a given point looks the same*/
	private int dx1,dy1; //corresponds to horisontal steps - x chenges
	private int dx2,dy2; //corresponds to vertical steps -y changes
	private Point p1,p2;
	private Point current;

	MovingPoint (Point p1,Point p2)
	{
		this.p1 = new Point(p1.x,p1.y);
		this.p2 = new Point(p2.x,p2.y);
		current = new Point(p1.x,p1.y);

		if(p1.x < p2.x)
		{
			dx1 = 1;dy1 = 0;
		}
		else
		{
			dx1 = -1;dy1 = 0;
		}


		if(p1.y < p2.y)
		{
			dx2 = 0;dy2 = 1;
		}
		else
		{
			dx2 = 0;dy2 = -1;
		}
	}
	/*returns true if point's traveling has already finished */	
	public boolean isDone()
	{
		return (current.x == p2.x &&current.y ==p2.y);
	}

	public Point step()
	{
		Point candidat1,candidat2;
		if(isDone())
			return(new Point (current.x, current.y));
		candidat1 = new Point(current.x + dx1,current.y + dy1);
		candidat2 = new Point(current.x + dx2,current.y + dy2);
		if(pseudo_distance(candidat1) < pseudo_distance(candidat2))
			current =  candidat1;
		else current = 	candidat2;
		return (new Point(current.x,current.y));
	}

	/* returns distance from a point to the line multiplied by the length of(y1-y2 ,-(x1-x2))*/
	private int pseudo_distance(Point p)
	{
		return Math.abs((p.x - p1.x)*(p2.y - p1.y) + (p.y - p1.y) * (p1.x - p2.x));
	}
}

		
