import java.awt.*;

public class MyCanvas extends Canvas implements Runnable
{
	public Splay tree = new Splay();  //tree in action
	public int sleeptime=0;			//time between two animation steps
										//(set with a button change speed)	
	private Graphics gContext;		 //used for double buffering
	private Image	OffscrImage;
	private BoundBoxedTree tree1,tree2;
	public Thread th; //the variable is defined public so that Control
					//can see it to stop the thread on "Suspend" pressed	
	public boolean running = true; //during an animation running is true
							//if the tree is locked by some operation on it
	public boolean active = true;//active == false if the tree is stable
								//run thread is suspended	
	public int button; // 0 - insert, 1 - delete, 2 - find
	public int arg ;  //control pass to rhe variable  value of a 
						//key(delete,insert,find,speed)
	public int pause = 50;//pause between actions
	public int tx,ty; // values of scrollbars
	public int width,height;	//dimensions of the image(not only of the visible part)
	private int VerticalDistance = 20; //distance between horizontal 
							//layers of nodes in the tree
	private Scrollbar vert,horz; //scrollbars , passed from control
	public Label InfoLabel; //passed from ArcControl.Used to show information 
						   //about actions (found,not found) ArcControls knows about
							//  MyCanvas from Control 


	public MyCanvas (Scrollbar vert,Scrollbar horz) 
	{
		//builds a tree just for fun
				
		tree1 = new
			BoundBoxedTree
			(
			 new BoundBoxedTree(new Node(new Point(130,140),1)),
			 new Node(300,26),
			 new BoundBoxedTree(new Node(new Point(70,50),5)));
  		tree2 = new
			BoundBoxedTree
			(
			 new BoundBoxedTree(new Node(new Point(130,140),7)),
			 new Node(new Point(300,26),10),
			 new BoundBoxedTree(new Node(new Point(70,50),15)));


		tree = new Splay( new BoundBoxedTree(tree1,new Node(new Point(30,300),6),tree2));
		this.vert = vert;			//initializing the scrollbars
		this.horz = horz;
		th = new Thread(this);
		th.start();

	}
	

	
	public void paint(Graphics g)
	{
		update( g);
	}


  	public  void  update(Graphics g)
	{								 
		int w = (Math.max(bounds().width , tree.getWidth()));;	 //dimensions fo the visible image
		int h = (Math.max(bounds().height , tree.getHeight()));//bounds().height;
		height = h;
		width = w;
		if ( OffscrImage != null)
		{
			//updating scrollbars and drawing the image
			vert.setValues(vert.getValue(),bounds().height,0,height - bounds().height);
			horz.setValues(horz.getValue(),bounds().width,0,width - bounds().width);
			ty = Math.min(height - bounds().height ,ty);
			tx = Math.min( width - bounds().width , tx); 
			g.translate(-tx,-ty);
			g.drawImage(OffscrImage,0,0,null);
		}
		if (OffscrImage == null
			|| OffscrImage.getWidth(null) != w
			|| OffscrImage.getHeight(null) != h)
		{
			OffscrImage = createImage(w, h);
			if ( OffscrImage != null)
			{
				if ( gContext != null)
					gContext.dispose();
			}
			gContext = OffscrImage.getGraphics();
		}
		gContext.setColor(Color.green);
		gContext.fillRect(0,0,w,h);
 
		if(tree.splay != null)
			synchronized (tree){
			tree.splay.draw(gContext);
		}
		


	}

	public void run()
	{	
		Tree returned;
		boolean busy=true,outerbusy = true;
		tree.splay.setVdistance(VerticalDistance);
		while (busy)
		{ 
			repaint();
			try{Thread.sleep(sleeptime);
				busy=tree.splay.step();
			}
			catch (Exception e) {System.out.println("wun's while(busy)"+e);};
		}


	////////////////////////////////////////////////////////////////////////////////////	
		/*************************end***********************/


	try{
		active = false;
		while (true)
		{
			while (!active)
				th.suspend();
			if ( button == 0)
				FineInsert(arg);
			if ( button == 1)
				FineDelete(arg);
			if ( button == 2)
				FineFind(arg);

			active = false;

		}
	}
			catch (Exception e) {System.out.println(e);};


	}
	public void FineFind(int key)
	{
		Tree returned = tree.locate(key);

		InfoLabel.setText(tree.CurrentMessage);

		if ( returned != null)
			FineSplay(returned);
	}

	public void FineDelete(int key)
	{
		Tree returned;
		if (tree.splay != null)
			synchronized(tree.splay)
			{
				returned =  tree.Delete(key);
			}
		else   returned =  tree.Delete(key);	//special case against synchronized(null)	
 		 for(int i = 1;i<3;i++)
		 {
			repaint();
			try{Thread.sleep(0);
			}
			catch (Exception e) {System.out.println("020");}; 
		 }			 

		InfoLabel.setText(tree.CurrentMessage);

		if ( returned != null)
			FineSplay(returned);
	}
	public void FineInsert(int key)
	{
		Tree returned;
		if (tree.splay != null)
			synchronized (tree.splay){
				returned = tree.Insert(key); }
		else   returned = tree.Insert(key);	 //special case against synchronized(null)
		InfoLabel.setText(tree.CurrentMessage);
 		for(int i = 1;i<5;i++)
			repaint();
		if ( returned != null)
			FineSplay(returned);
	}

	public void FineSplay(Tree returned)
	{
	  boolean busy = true,outerbusy = true ;
	  /* busy - true if animation of splay step is in process
	     outerbusy - true if splayed node isn't at the root */
      while(outerbusy)
	  {
			/*****************splaying******************************/
		for(int i=1;i<5;i++)
		{
			repaint();
			try{Thread.sleep(pause);}catch  (Exception e) {System.out.println("090");};
		}
		 outerbusy = tree.SplayStep(returned);
 		 for(int i = 1;i<5;i++)
		 {
			repaint();
			try{Thread.sleep(pause);
			}
			catch (Exception e) {System.out.println(e.toString());}; 
		 }			 

	  	tree.splay.setVdistance(VerticalDistance);	//calls updateInfo and BestFit

		while (busy)
		{ 
			repaint();
			this.getToolkit().sync();
			try{Thread.sleep(sleeptime);
			synchronized (tree.splay){
				busy=tree.splay.step();}
			
				while (!running)
					th.suspend(); 
			}
			catch (Exception e) {System.out.println("040");};
		}
		busy = true;
	  }	  //outer while's 
	}
}
