import java.awt.*;
public class Node extends Point
{
	private int val=2, radius = 10;

	Node()
	{
		super( 30,30);
		val = 0;
		radius = 10;
	}

	Node (int x,int y,int r)
	{
		this(x,y);
		radius=r;
	}

	Node (int x, int y)		       
	{
		super(x,y);
	}

	Node (Node node) //copy constructor
	{
		super(node.x,node.y);
		this.val = node.val;
		this.radius = node.radius;
	}
		
	Node (Point center,int val)
	{
		this(center.x,center.y);
		this.val = val;
	}
	public void draw(Graphics g)
	{
		Font f = new Font ("Helvetica",Font.BOLD,12);
		g.setFont(f);
		g.setColor(java.awt.Color.red);
	    g.fillOval (x-2,y-2,2*radius+4,2*radius+4);
		g.setColor(Color.yellow); 
		g.fillOval (x,y,2*radius,2*radius);
        g.setColor (Color.black);	
		if ( val > 9)
		 g.drawString (String.valueOf(val),x+3,y+15) ;	 
		else  g.drawString (String.valueOf(val),x+6,y+15) ;	 
	}

	
	public int getRadius()
	{
		return(radius + 2);	//radius of outer oval
	}
	public Point center()
	{
		return (new Point (x + radius, y + radius));
	}

	public void center(Point p)
	{
		x = p.x - radius;
		y = p.y - radius;
	}
	public int getValue()
	{
		return val;
	}

	public void setValue(int value)
	{
		val = value;
	}
}

